﻿using System;
using System.Collections.Generic;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using AsReaderP51N;
using System.Threading;
using System.Runtime.InteropServices;
using System.IO.Ports;
using System.Text.RegularExpressions;
using System.IO;
using System.Configuration;

namespace AsReaderP51N_Demo_Tool
{
    public partial class AsReaderP51N_Demo_Tool : Form
    {
        private int total_time = 0;//The total time.
        int singluationCount = 0;
        volatile bool m_bInventory = false;
        bool isConnected = false;
        int selectedIndex = 0;
        string connType = "";
        
        private Hashtable mTagHashTable = new Hashtable();
        private delegate void ProcessDelegate();

        public AsReaderP51N_Demo_Tool()
        {
            InitializeComponent();
        }

        /// <summary>
        /// UDP Search
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnSearch_Click(object sender, EventArgs e)
        {
            btnSearch.Enabled = false;
            Cursor.Current = Cursors.WaitCursor;
            cmbTCPIPAddr.Items.Clear();
            cmbTCPIPAddr.Text = "";
            List<string> ipList = new List<string>();
            Device.GetDeviceIPInformation(ref ipList);

            if (ipList != null && ipList.Count > 0)
            {
                foreach (string item in ipList)
                {
                    if (item != "") cmbTCPIPAddr.Items.Add(item);
                }

            }
            if (cmbTCPIPAddr.Items.Count > 0)
            {
                this.Devmes.AppendText(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + " Search success." + Environment.NewLine);
                this.Devmes.ScrollToCaret();
            }
            else
            {

                this.Devmes.AppendText(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + " IP address not found." + Environment.NewLine);
                this.Devmes.ScrollToCaret();
            }
            btnSearch.Enabled = true;
        }

        private void initForms()
        {
            SetCombolList();
            string[] vcpPort = GetPortList();
            int i = 0;
            //有限判断是否开通端口模式
            if (vcpPort.Length > 0)
            {
                for (i = 0; i < vcpPort.Length; i++)
                {
                    this.ComPort.Items.Add(vcpPort[i]);
                }
                if (i > 0)
                    this.ComPort.SelectedIndex = 0;
            }
        }

        /// <summary>
        /// VCP disconnect
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnVcpDisconnect_click(object sender, EventArgs e)
        {
            if (m_bInventory) StopInventory();
            UInt32 error = 0;
            error = Device.Disconnect();

            if (error == 0)
            {
                this.ComPort.Enabled = true;
                this.Scan.Enabled = true;
                this.txtBaudRate.Enabled = true;
                this.Connect.Enabled = true;
                this.button5.Enabled = true;
                this.btnVcpDisConn.Enabled = false;
                isConnected = false;
            }
            else
            {
                Devmes.AppendText(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + "Disconnect failed.(" + error + ")" + Environment.NewLine);
                Devmes.ScrollToCaret();
            }
           
            this.ControlsEnabled();
        }

        private void button4_Click(object sender, EventArgs e)
        {
            string[] ports = SerialPort.GetPortNames();
            UInt32 i = 0;

            ComPort.Items.Clear();//清除当前存在的端口
            if (ports.Length > 0)
            {
                for (i = 0; i < ports.Length; i++)
                {
                    ComPort.Items.Add(ports[i]);
                }
                if (i > 0)
                    ComPort.SelectedIndex = 0;
            }
        }

        /// <summary>
        /// VCP Connect
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button1_Click(object sender, EventArgs e)
        {
            Cursor.Current = Cursors.WaitCursor;
            connType = "VCP";
            uint error = 0;
            if (ComPort.Text.Length > 0)
            {
                string com_name = this.ComPort.SelectedItem.ToString();
                error = Device.ConnectWithVcp(com_name);
                if (error == 0)
                {
                    isConnected = true;
                    btnGetRegion(button2, e);
                    btnGetAntenna_Click(button8, e);
                    GetPower_Click(GetPower, e);
                    GetMode_Click(GetMode, e);
                    GetSession_Click(GetSession, e);
                    btnGetSearch_Click(GetSearch, e);
                    button1_Click_2(button1, e);
                    GetFirm();
                }
                else
                {
                    Devmes.AppendText(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + " Connect failed.(" + error + ")" + Environment.NewLine);
                }
            }
            else
            {
                Devmes.AppendText(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + " COM port is not exist,please check it." + Environment.NewLine);
            }

            Devmes.ScrollToCaret();
            this.ControlsEnabled();
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button1_Click_1(object sender, EventArgs e)
        {
            UInt32 error = 0;
            DatalistView.Items.Clear();
            lblCount.Text = "";
            error = Device.StartInventory(true, true, true, true, true, true, true);
            MessageBox.Show(error.ToString());
        }
        
        private void btnSetAntenna_Click(object sender, EventArgs e)
        {
            UInt32 error = 0;
            error = Device.SetAntennaPorts(An1.Checked, An2.Checked, An3.Checked, An4.Checked);

            this.Devmes.AppendText(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + (error == 0 ? " Set antenna command sent successfully." : " Set antenna command sent failed.") + Environment.NewLine);
            this.Devmes.ScrollToCaret();
        }

        private void Write_Epc_Click(object sender, EventArgs e)
        {
            //input check
            string needMsg = "";
            if (txtEpc.Text == "") needMsg += DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + " [WARNING]Please input write memory content." + Environment.NewLine;
            if (text_off.Text == "") needMsg += DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + " [WARNING]Please input start address." + Environment.NewLine;
            if (needMsg != "")
            {
                this.Devmes.AppendText(needMsg);
                this.Devmes.ScrollToCaret();
                return;
            }
            //handle
            UInt32 error = 0;
            string Epc_string = this.txtEpc.Text.Replace(" ", "").Replace("0x", "");

            if (Epc_string.Length % 2 != 0)
            {
                this.Devmes.AppendText(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + " Please input correct write memory content." + Environment.NewLine);
                this.Devmes.ScrollToCaret();
                return;
            }
            byte[] yu = { };
            yu = HexStringToByteArray(Epc_string);
            //Epc_string1 选中的要被覆盖的标签的值
            string Epc_string1 = this.txtSelectedTag.Text.Replace(" ", "").Replace("0x", "");

            if (Epc_string1.Length % 2 != 0)
            {
                this.Devmes.AppendText(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + " Please input correct epc of selected." + Environment.NewLine);
                this.Devmes.ScrollToCaret();
                return;
            }
            byte[] ren = { };
            ren = HexStringToByteArray(Epc_string1);
            error = Device.WriteMemory(
                SELSERVED.Checked ? Types.MemBankType.MEM_RESERVED : SELEPC.Checked ? Types.MemBankType.MEM_EPC : SELTID.Checked ? Types.MemBankType.MEM_TID : SELUSER.Checked ? Types.MemBankType.MEM_USER : 0,
                Convert.ToUInt32(text_off.Text),
                Convert.ToUInt32(ReadPassward.Text == "" ? "0" : ReadPassward.Text, 16), yu, ren);

            this.Devmes.AppendText(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + (error == 0 ? " Write tag command sent successfully." : " Write tag command sent failed.") + Environment.NewLine);
            this.Devmes.ScrollToCaret();
        }

        static byte[] HexStringToByteArray(string s)
        {
            s = s.Replace(" ", "").Replace("0x", "");
            byte[] buffer = new byte[s.Length / 2];
            for (int i = 0; i < s.Length; i += 2)
                buffer[i / 2] = (byte)Convert.ToByte(s.Substring(i, 2), 16);
            return buffer;
        }

        private void ReadTag_Click(object sender, EventArgs e)
        {
            UInt32 error = 0;
            string Epc_string = this.txtSelectedTag.Text.Replace(" ", "").Replace("0x", "");

            //input value check
            StringBuilder sb = new StringBuilder();
            if (Epc_string.Length % 2 != 0) sb.AppendLine(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + " [WARNING]Please input correct epc of selected.");
            if (text_off.Text == "") sb.AppendLine(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + " [WARNING]Please input start address.");
            if (ReadLenth.Text == "") sb.AppendLine(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + " [WARNING]Please input length.");
            if (sb.ToString().Length > 0)
            {
                this.Devmes.AppendText(sb.ToString());
                this.Devmes.ScrollToCaret();
                return;
            }

            byte[] yu = { };
            yu = HexStringToByteArray(Epc_string);
            error = Device.ReadMemory(
                SELSERVED.Checked ? Types.MemBankType.MEM_RESERVED : SELEPC.Checked ? Types.MemBankType.MEM_EPC : SELTID.Checked ? Types.MemBankType.MEM_TID : SELUSER.Checked ? Types.MemBankType.MEM_USER : 0,
                Convert.ToUInt32(text_off.Text),
                Convert.ToUInt32(ReadLenth.Text),
                Convert.ToUInt32(ReadPassward.Text == "" ? "0" : ReadPassward.Text, 16),
                yu);

            this.Devmes.AppendText(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + (error == 0 ? " Read tag command sent successfully." : " Read tag command sent failed.") + Environment.NewLine);
            this.Devmes.ScrollToCaret();
        }

        private void btnSelectMask_Click(object sender, EventArgs e)
        {
            UInt32 error = 0;

            string Epc_string = this.txtSelectedTag.Text.Replace(" ", "").Replace("0x", "");
            byte[] yu = { };
            if (Epc_string.Length % 2 != 0)
            {
                this.Devmes.AppendText(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + " Please input correct epc of selected." + Environment.NewLine);
                this.Devmes.ScrollToCaret();
                return;
            }
            yu = HexStringToByteArray(Epc_string);

            error = Device.SetSelectMask(
                SELSERVED.Checked ? Types.MemBankType.MEM_RESERVED : SELTID.Checked ? Types.MemBankType.MEM_TID : SELEPC.Checked ? Types.MemBankType.MEM_EPC : SELUSER.Checked ? Types.MemBankType.MEM_USER : 0,
                (Types.TargetType)cmbTarget.SelectedIndex,
                (Types.ActionType)cmbAction.SelectedIndex,
                Convert.ToUInt32(SelOffset.Text, 16),
                yu);
            this.Devmes.AppendText(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + (error == 0 ? " Select command sent successfully." : " Select command sent failed.") + Environment.NewLine);
            this.Devmes.ScrollToCaret();
        }

        /// <summary>
        /// TCP Connect
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button5_Click(object sender, EventArgs e)
        {
            Cursor.Current = Cursors.WaitCursor;
            if (cmbTCPIPAddr.Text == "")
            {
                Devmes.AppendText(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + " Please input IP address." + Environment.NewLine);
                Devmes.ScrollToCaret();
                return;
            }
            this.button5.Enabled = false;
            UInt32 error = 0;
            error = Device.ConnectWithTcp(cmbTCPIPAddr.Text, TcpPort.Text);
            if (error == 0)
            {
                btnGetRegion(button2, e);
                btnGetAntenna_Click(button8, e);
                GetPower_Click(GetPower, e);
                GetMode_Click(GetMode, e);
                GetSession_Click(GetSession, e);
                btnGetSearch_Click(GetSearch, e);
                button1_Click_2(button1, e);
                GetFirm();

                if (getRegionErr && getAntennaErr && getPowerErr && getModeErr && getSessionErr && getSearchErr && getFirmErr) {

                    this.button5.Enabled = true;
                    Devmes.AppendText(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + " Connect failed.(" + error + ")" + Environment.NewLine);
                    Devmes.ScrollToCaret();
                    return;
                }
            }
            else
            {
                Devmes.AppendText(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + " Connect failed.(" + error + ")" + Environment.NewLine);
                Devmes.ScrollToCaret();
                this.button5.Enabled = true;
                return;
            }

            isConnected = true;
            connType = "TCP";
            this.ControlsEnabled();
        }

        /// <summary>
        /// TCP disconnect
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnTcpDiscon_Click(object sender, EventArgs e)
        {
            if (m_bInventory) StopInventory();
            UInt32 error = 0;
            error = Device.Disconnect();

            if (error == 0)
            {
                this.ComPort.Enabled = true;
                this.Scan.Enabled = true;
                this.txtBaudRate.Enabled = true;
                this.Connect.Enabled = true;
                this.button5.Enabled = true;
                this.btnVcpDisConn.Enabled = false;
                isConnected = false;
            }
            else
            {
                Devmes.AppendText(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + "Disconnect failed.(" + error + ")" + Environment.NewLine);
                Devmes.ScrollToCaret();
            }
            this.ControlsEnabled();
        }

        /// <summary>
        /// 
        /// </summary>
        void buttonEnabled() {
            this.Connect.Enabled = this.button5.Enabled;
            this.btnVcpDisConn.Enabled = (this.button5.Enabled && this.Connect.Enabled) || (!this.button5.Enabled || !this.Connect.Enabled);
        }

        /// <summary>
        /// kill tag
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnKill_Click(object sender, EventArgs e)
        {
            string Epc_string = txtSelectedTag.Text.Replace(" ", "").Replace("0x", "");
            byte[] yu = { };

            if (Epc_string.Length % 2 != 0)
            {
                this.Devmes.AppendText(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + " Please input correct epc of selected." + Environment.NewLine);
                this.Devmes.ScrollToCaret();
                return;
            }
            yu = HexStringToByteArray(Epc_string);
            UInt32 error = Device.Kill(Convert.ToUInt32(ReadPassward.Text == "" ? "0" : ReadPassward.Text, 16), yu);

            this.Devmes.AppendText(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + (error == 0 ? " Kill tag command sent successfully." : " Kill tag command sent failed.") + Environment.NewLine);
            this.Devmes.ScrollToCaret();
        }

        private void SetPower_Click(object sender, EventArgs e)
        {
            UInt32 error = 0;
            string msg = "";
            UInt32 tmp;
            if (PoweText.Text == "" || UInt32.TryParse(PoweText.Text, out tmp) == false)
            {
                msg = DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + " [WARNING]" + "Please input the correct power.";
                this.PoweText.Focus();
            }
            else
            {
                error = Device.SetTxPower(tmp);
                msg = DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + (error == 0 ? " Set power command sent successfully." : " Set power command sent failed.");
            }
            this.Devmes.AppendText(msg + Environment.NewLine);
            this.Devmes.ScrollToCaret();
        }

        bool getPowerErr = false;
        private void GetPower_Click(object sender, EventArgs e)
        {
            UInt32 power = 0;
            UInt32 error = 0;
            error = Device.GetTxPower(ref power);
            if (error == 0)
            {
                PoweText.Text = power.ToString();
                getPowerErr = false;
            }
            else {
                getPowerErr = true;
            }
            this.Devmes.AppendText(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + (error == 0 ? " Get power command sent successfully." : " Get power command sent failed.") + Environment.NewLine);
            this.Devmes.ScrollToCaret();
        }

        bool getAntennaErr = false;
        /// <summary>
        /// get ant
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnGetAntenna_Click(object sender, EventArgs e)
        {
            UInt32 error = 0;
            bool an1 = false;
            bool an2 = false;
            bool an3 = false;
            bool an4 = false;
            error = Device.GetAntennaPorts(ref an1, ref an2, ref an3, ref an4);
            if (error == 0)
            {
                this.An1.Checked = an1;
                this.An2.Checked = an2;
                this.An3.Checked = an3;
                this.An4.Checked = an4;
                getAntennaErr = false;
            }
            else {
                getAntennaErr = true;
            }
            this.Devmes.AppendText(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + (error == 0 ? " Get antenna command sent successfully." : " Get antenna command sent failed.") + Environment.NewLine);
            this.Devmes.ScrollToCaret();
        }
        
        private void Clear_Click(object sender, EventArgs e)
        {
            total_time = System.Environment.TickCount;
            ClearTableData();
        }

        private void SetRFMode_Click(object sender, EventArgs e)
        {
            UInt32 error = 0;
            //设定值范围：0~4
            error = Device.SetRfMode((Types.RfMode)cmbMode.SelectedIndex);
            
            this.Devmes.AppendText(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + (error == 0 ? " Set mode command sent successfully." : " Set mode command sent failed.") + Environment.NewLine);
            this.Devmes.ScrollToCaret();
        }

        bool getModeErr = false;
        private void GetMode_Click(object sender, EventArgs e)
        {
            Types.RfMode rfmode = 0;
            UInt32 error = 0;
            error = Device.GetRfMode(ref rfmode);
            if (error == 0)
            {
                cmbMode.SelectedIndex = (Int32)rfmode;
                getModeErr = false;
            }
            else { 
                getModeErr = true;
            }

            this.Devmes.AppendText(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + (error == 0 ? " Get mode command sent successfully." : " Get mode failed.") + Environment.NewLine);
            this.Devmes.ScrollToCaret();
        }

        private void SetSession_Click(object sender, EventArgs e)
        {
            UInt32 error = 0;
            //session范围：0~3
            error = Device.SetSession((Types.SessionType)cmbSessioin.SelectedIndex);
            
            this.Devmes.AppendText(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + (error == 0 ? " Set session command sent successfully." : " Set session command sent failed.") + Environment.NewLine);
            this.Devmes.ScrollToCaret();
        }

        bool getSessionErr = false;
        private void GetSession_Click(object sender, EventArgs e)
        {
            Types.SessionType sessionType = 0;
            UInt32 error = 0;
            error = Device.GetSession(ref sessionType);
            if (error == 0)
            {
                cmbSessioin.SelectedIndex = Convert.ToInt32(sessionType);
                getSessionErr = false;
            }
            else { 
                getSessionErr = true;
            }

            this.Devmes.AppendText(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + (error == 0 ? " Get session command sent successfully." : " Get session command sent failed.") + Environment.NewLine);
            this.Devmes.ScrollToCaret();
        }

        private void btnSetSearch_Click(object sender, EventArgs e)
        {
            UInt32 error = 0;
            //SearchMode:0~3
            error = Device.SetSearchMode((Types.SearchMode)cmbSearch.SelectedIndex);
            
            this.Devmes.AppendText(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + (error == 0 ? " Set search command sent successfully." : " Set search command sent failed.") + Environment.NewLine);
            this.Devmes.ScrollToCaret();
        }

        bool getSearchErr = false;
        private void btnGetSearch_Click(object sender, EventArgs e)
        {
            Types.SearchMode searchMode = 0;
            UInt32 error = 0;
            error = Device.GetSearchMode(ref searchMode);

            if (error == 0)
            {
                cmbSearch.SelectedIndex = Convert.ToInt32(searchMode);
                getSearchErr = false;
            }
            else { 
                getSearchErr = true;
            }
            this.Devmes.AppendText(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + (error == 0 ? " Get search command sent successfully." : " Get search command sent failed.") + Environment.NewLine);
            this.Devmes.ScrollToCaret();
        }

        private void button1_Click_3(object sender, EventArgs e)
        {
            string firmwareVer = "";
            UInt32 error = 0;
            error = Device.GetFirmwareVersion(ref firmwareVer);
            if (error == 0)
            {
                txtFirm.Text = firmwareVer;
            }
            else {
                string msg = DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + " Get firm failed.(" + error + ")";
                this.Devmes.AppendText(msg + Environment.NewLine);
                this.Devmes.ScrollToCaret();
            }
        }

        bool getFirmErr = false;
        private void GetFirm() {
            string firmwareVer = "";
            string sdkversion = "";
            UInt32 error = 0;
            error = Device.GetFirmwareVersion(ref firmwareVer);
            if (error == 0)
            {
                txtFirm.Text = firmwareVer;
                getFirmErr = false;
            }
            else {
                getFirmErr = true;
            }
            this.Devmes.AppendText(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + (error == 0 ? " Get firm command sent successfully." : " Get firm command sent failed.") + Environment.NewLine);

            Device.GetSdkVersion(ref sdkversion);
            tx_sdkversion.Text = sdkversion;
            this.Devmes.AppendText(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") +" Get SDK Version" + Environment.NewLine);
            this.Devmes.ScrollToCaret();
        }
        
        /// <summary>
        /// set region
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnRegion_Click(object sender, EventArgs e)
        {
            UInt32 error = 0;
            Types.RegionType region = Types.RegionType.REGION_FCC_PART_15_247;

            if (rbUsband.Checked)
            {
                region = Types.RegionType.REGION_FCC_PART_15_247;
            }
            if (rbEuBand.Checked)
            {
                region = Types.RegionType.REGION_ETSI_EN_302_208_V1_4_1;
            }
            if (rbJpband.Checked)
            {
                region = Types.RegionType.REGION_JAPAN_916_921_MHZ_NO_LBT;
            }
            if (rbKoreanband.Checked)
            {
                region = Types.RegionType.REGION_KOREA_917_921_MHZ;
            }
            if (rbChinaband.Checked)
            {
                region = Types.RegionType.REGION_CHINA_920_925_MHZ;
            }

            error = Device.SetRegion(region);

            this.Devmes.AppendText(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + (error == 0 ? " Set region command sent successfully." : " Set region command sent failed.") + Environment.NewLine);
            this.Devmes.ScrollToCaret();

            if (error == 0)
            {
                GetMode_Click(GetMode, e);
            }
        }

        bool getRegionErr = false;
        private void btnGetRegion(object sender, EventArgs e)
        {
            UInt32 error = 0;
            Types.RegionType region = Types.RegionType.REGION_FCC_PART_15_247;
            error = Device.GetRegion(ref region);
            if (error == 0)
            {
                if (region == Types.RegionType.REGION_FCC_PART_15_247)
                {
                    rbUsband.Checked = true;
                }
                if (region == Types.RegionType.REGION_ETSI_EN_302_208_V1_4_1)
                {
                    rbEuBand.Checked = true;
                }
                if (region == Types.RegionType.REGION_JAPAN_916_921_MHZ_NO_LBT)
                {
                    rbJpband.Checked = true;
                }
                if (region == Types.RegionType.REGION_KOREA_917_921_MHZ)
                {
                    rbKoreanband.Checked = true;
                }
                if (region == Types.RegionType.REGION_CHINA_920_925_MHZ)
                {
                    rbChinaband.Checked = true;
                }
                getRegionErr = false;
            }
            else {
                getRegionErr = true;
            }

            this.Devmes.AppendText(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + (error == 0 ? " Get region command sent successfully." : " Get region command sent failed.") + Environment.NewLine);
            this.Devmes.ScrollToCaret();
        }

        /// <summary>
        /// start inventory click
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void startInventory_Click(object sender, EventArgs e)
        {
            UInt32 error = 0;
            string msg = "";
            this.StartInventory.Enabled = false;
            if (m_bInventory)
            {
                error = Device.StopInventory();
                if (error != 0)
                {
                    msg = DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + " Stop inventory command sent failed.(" + error + ")";
                    this.Devmes.AppendText(msg + Environment.NewLine);
                    this.Devmes.ScrollToCaret();
                    this.StartInventory.Enabled = true;
                    return;
                }
                m_bInventory = false;
                this.StartInventory.Text = "Start";
                readTimer.Enabled = false;
            }
            else if (!m_bInventory)
            {
                error = Device.StartInventory(true, true, true, true, true, true, true);
                if (error != 0)
                {
                    msg = DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + " Start inventory command sent failed(." + error + ")";
                    this.Devmes.AppendText(msg + Environment.NewLine);
                    this.Devmes.ScrollToCaret();
                    this.StartInventory.Enabled = true;
                    return;
                }
                total_time = System.Environment.TickCount;
                ClearTableData();
                this.StartInventory.Text = "Stop";
                m_bInventory = true;
                readTimer.Enabled = true;
            }
            this.StartInventory.Enabled = true;
        }

        private void AsReaderBoxP51N_Demo_Tool_Load(object sender, EventArgs e)
        {
            this.initForms();
            this.ControlsEnabled();
            Device.callBackResultTagData = ShowTagData;
            Device.callBackResultError = ShowErrorMsg;
        }
        /// <summary>
        /// 扫描列表行选中时，将当前的标签内容放置到access tag的tab控件中
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void DatalistView_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (this.DatalistView.SelectedItems.Count > 0)
            {
                ListViewItem row = this.DatalistView.SelectedItems[0];
                if (row != null && row.SubItems[1] != null && row.SubItems[1].Text != null)
                {
                    txtSelectedTag.Text = row.SubItems[1].Text;
                    selectedIndex = this.DatalistView.SelectedItems[0].Index;
                }
            }
        }

        private void SelOffset_KeyPress(object sender, KeyPressEventArgs e)
        {
            e.Handled = ("0123456789ABCDEF".IndexOf(Char.ToUpper(e.KeyChar)) < 0);
        }

        private void ReadLenth_KeyPress(object sender, KeyPressEventArgs e)
        {
            e.Handled = ("0123456789ABCDEF".IndexOf(Char.ToUpper(e.KeyChar)) < 0);
        }

        private void password_text_KeyPress(object sender, KeyPressEventArgs e)
        {
            e.Handled = ("0123456789ABCDEF".IndexOf(Char.ToUpper(e.KeyChar)) < 0);
        }

        private void text_off_KeyPress(object sender, KeyPressEventArgs e)
        {
            e.Handled = ("0123456789ABCDEF".IndexOf(Char.ToUpper(e.KeyChar)) < 0);
        }

        private void txtEpc_KeyPress(object sender, KeyPressEventArgs e)
        {
            e.Handled = ("0123456789ABCDEF".IndexOf(Char.ToUpper(e.KeyChar)) < 0);
        }

        private void ReadPassward_KeyPress(object sender, KeyPressEventArgs e)
        {
            e.Handled = ("0123456789ABCDEF".IndexOf(Char.ToUpper(e.KeyChar)) < 0);
        }

        /// <summary>
        /// lock tag
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void buttonLock_Click(object sender, EventArgs e)
        {
            UInt32 error = 0;
            string Epc_string = txtSelectedTag.Text.Replace(" ", "").Replace("0x", "");
            byte[] yu = { };

            if (Epc_string.Length % 2 != 0)
            {
                this.Devmes.AppendText(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + " Please input correct epc." + Environment.NewLine);
                this.Devmes.ScrollToCaret();
                return;
            }
            yu = HexStringToByteArray(Epc_string);
            AsReader.TagMask tagMask = new AsReader.TagMask();
            tagMask.userMemoryBit1 = cbMaskUser1.Checked;
            tagMask.userMemoryBit2 = cbMaskUser2.Checked;
            tagMask.tidMemoryBit1 = cbMaskTID1.Checked;
            tagMask.tidMemoryBit2 = cbMaskTID2.Checked;
            tagMask.epcMemoryBit1 = cbMaskEPC1.Checked;
            tagMask.epcMemoryBit2 = cbMaskEPC2.Checked;
            tagMask.accessMemoryBit1 = cbMaskAccess1.Checked;
            tagMask.accessMemoryBit2 = cbMaskAccess2.Checked;
            tagMask.killPwdMemoryBit1 = cbMaskKill1.Checked;
            tagMask.killPwdMemoryBit2 = cbMaskKill2.Checked;

            AsReader.TagAction tagAction = new AsReader.TagAction();
            tagAction.userMemoryBit1 = cbActionUser1.Checked;
            tagAction.userMemoryBit2 = cbActionUser2.Checked;
            tagAction.tidMemoryBit1 = cbActionTID1.Checked;
            tagAction.tidMemoryBit2 = cbActionTID2.Checked;
            tagAction.epcMemoryBit1 = cbActionEPC1.Checked;
            tagAction.epcMemoryBit2 = cbActionEPC2.Checked;
            tagAction.accessMemoryBit1 = cbActionAccess1.Checked;
            tagAction.accessMemoryBit2 = cbActionAccess2.Checked;
            tagAction.killPwdMemoryBit1 = cbActionKill1.Checked;
            tagAction.killPwdMemoryBit2 = cbActionKill2.Checked;

            error = Device.LockMemory(tagMask, tagAction, Convert.ToUInt32(ReadPassward.Text == "" ? "0" : ReadPassward.Text, 16), yu);

            this.Devmes.AppendText(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + (error == 0 ? " Lock tag command sent successfully." : " Lock tag command sent failed.") + Environment.NewLine);
            this.Devmes.ScrollToCaret();
        }

        private void ClearTableData()
        {
            mTagHashTable.Clear();
            this.DatalistView.Items.Clear();
            selectedIndex = 0;
            this.Devmes.Text = "";
            this.lblCount.Text = "0";
            singluationCount = 0;
            lblTotalDuration.Text = "0";
            lblTotalSingulation.Text = "0";
            lblTotalUnique.Text = "0";
            lblSingulationRate.Text = "0";
        }

        /// <summary>
        /// 
        /// </summary>
        private void ControlsEnabled()
        {
            //isConnected:true => connect succeed
            this.gbRegion.Enabled = isConnected;
            this.InventorySet.Enabled = isConnected;
            this.gbSetGet.Enabled = isConnected;
            this.tabControl2.Enabled = isConnected;
            this.SelectTag.Enabled = isConnected;
            this.groupBox4.Enabled = isConnected;
            this.LockTag.Enabled = isConnected;
            this.Connect.Enabled = !isConnected;
            this.btnVcpDisConn.Enabled = isConnected && connType == "VCP";
            this.button5.Enabled = !isConnected;
            this.btnTCPDisconn.Enabled = isConnected && connType == "TCP";
            this.ComPort.Enabled = !isConnected;
            this.Scan.Enabled = !isConnected;
            this.txtBaudRate.Enabled = !isConnected;
            this.TcpPort.Enabled = !isConnected;
            this.cmbTCPIPAddr.Enabled = !isConnected;
            this.textBox4.Enabled = !isConnected;
            this.btnSearch.Enabled = !isConnected;
            this.gbType.Enabled = isConnected;
        }

        /// <summary>
        /// 
        /// </summary>
        private void SetCombolList() {
            this.cmbTarget.DataSource = Device.getComboxList(typeof(Types.TargetType));
            this.cmbTarget.DisplayMember = "name";
            this.cmbTarget.ValueMember = "value";
            this.cmbTarget.SelectedIndex = 0;

            this.cmbAction.DataSource = Device.getComboxList(typeof(Types.ActionType));
            this.cmbAction.DisplayMember = "name";
            this.cmbAction.ValueMember = "value";
            this.cmbAction.SelectedIndex = 0;

            this.cmbMode.DataSource = Device.getComboxList(typeof(Types.RfMode));
            this.cmbMode.DisplayMember = "name";
            this.cmbMode.ValueMember = "value";
            this.cmbMode.SelectedIndex = 0;

            this.cmbSessioin.DataSource = Device.getComboxList(typeof(Types.SessionType));
            this.cmbSessioin.DisplayMember = "name";
            this.cmbSessioin.ValueMember = "value";
            this.cmbSessioin.SelectedIndex = 0;

            this.cmbSearch.DataSource = Device.getComboxList(typeof(Types.SearchMode));
            this.cmbSearch.DisplayMember = "name";
            this.cmbSearch.ValueMember = "value";
            this.cmbSearch.SelectedIndex = 0;
        }

        private void StopInventory()
        {
            StartInventory.Enabled = false;
            readTimer.Enabled = false;
            //if (m_bInventory) while (Device.StopInventory() != 0) ;
            if (m_bInventory) {
                Device.StopInventory();
            }
            m_bInventory = false;
            StartInventory.Text = "Start";
            StartInventory.Enabled = true;
        }
 
        public static string[] GetPortList()
        {
            return SerialPort.GetPortNames();
        }

        void SetReaderTagDataList(AsReader.InventoryResult tagcallbackdata) {
            singluationCount++;
            var arg = new object[6];
            string epc = tagcallbackdata.tagdata.epc;
            string tid = tagcallbackdata.tagdata.tid;
            arg[1] = epc;
            arg[2] = tid;
            arg[3] = tagcallbackdata.rssi;
            arg[4] = tagcallbackdata.tagdata.data;
            if (epc != null)
            {
                if (!mTagHashTable.ContainsKey(epc))
                {
                    arg[5] = (uint)1;
                    mTagHashTable.Add(epc, this.DatalistView.Items.Count);

                    ListViewItem item = new ListViewItem();
                    item.Text = (this.DatalistView.Items.Count + 1).ToString();
                    item.SubItems.Add(Convert.ToString(tagcallbackdata.tagdata.epc));
                    item.SubItems.Add(Convert.ToString(tagcallbackdata.tagdata.tid));
                    item.SubItems.Add(Convert.ToString(tagcallbackdata.rssi));
                    item.SubItems.Add(Convert.ToString(tagcallbackdata.tagdata.data));
                    item.SubItems.Add(Convert.ToString(tagcallbackdata.antenna));
                    item.SubItems.Add("1");
                    this.DatalistView.Items.Add(item);
                }
                else
                {
                    int count = (int)mTagHashTable[epc];
                    ListViewItem item = this.DatalistView.Items[count];
                    item.SubItems[3].Text = Convert.ToString(tagcallbackdata.rssi);
                    item.SubItems[4].Text = Convert.ToString(tagcallbackdata.tagdata.data);
                    item.SubItems[5].Text = Convert.ToString(tagcallbackdata.antenna);
                    item.SubItems[6].Text = (Convert.ToInt32(item.SubItems[6].Text) + 1).ToString();
                }

            }
            if (epc == null && tid != null)
            {
                if (!mTagHashTable.ContainsKey(tid))
                {
                    arg[5] = (uint)1;
                    mTagHashTable.Add(tid, this.DatalistView.Items.Count);

                    ListViewItem item = new ListViewItem();
                    item.Text = (this.DatalistView.Items.Count + 1).ToString();
                    item.SubItems.Add(Convert.ToString(tagcallbackdata.tagdata.epc));
                    item.SubItems.Add(Convert.ToString(tagcallbackdata.tagdata.tid));
                    item.SubItems.Add(Convert.ToString(tagcallbackdata.rssi));
                    item.SubItems.Add(Convert.ToString(tagcallbackdata.tagdata.data));
                    item.SubItems.Add(Convert.ToString(tagcallbackdata.antenna));
                    item.SubItems.Add("1");
                    this.DatalistView.Items.Add(item);
                }
                else
                {
                    int count = (int)mTagHashTable[tid];

                    ListViewItem item = this.DatalistView.Items[count];
                    item.SubItems[3].Text = Convert.ToString(tagcallbackdata.rssi);
                    item.SubItems[4].Text = Convert.ToString(tagcallbackdata.tagdata.data);
                    item.SubItems[5].Text = Convert.ToString(tagcallbackdata.antenna);
                    item.SubItems[6].Text = (Convert.ToInt32(item.SubItems[6].Text) + 1).ToString();
                }
            }

            lblTotalSingulation.Text = singluationCount.ToString();
            lblTotalUnique.Text = DatalistView.Items.Count.ToString();
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="rdtag"></param>
        private void ShowTagData(AsReader.InventoryResult rdtag) {
            ProcessDelegate mainProcess = delegate ()
            {
                SetReaderTagDataList(rdtag);
                
                if (this.DatalistView.Items.Count > 0)
                {
                    this.DatalistView.Items[selectedIndex].Selected = true;
                    this.DatalistView.Items[selectedIndex].EnsureVisible();
                }
                this.lblCount.Text = this.DatalistView.Items.Count.ToString();
            };

            this.Invoke(mainProcess);
               
        }

        private void ShowErrorMsg(uint error)
        {
            ProcessDelegate mainProcess = delegate ()
            {
                ShowErrorMessage(error);
            };

            this.Invoke(mainProcess);
        }

        private void ShowErrorMessage(uint error) {
            if (Enum.IsDefined(typeof(Types.ErrorCode), Convert.ToInt32(error)))
            {
                string message = Enum.Parse(typeof(Types.ErrorCode), Convert.ToString(error)).ToString();
                this.Devmes.AppendText(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + " 0x" + Convert.ToString(error, 16) + ":" + message + Environment.NewLine);
            }
            else {
                this.Devmes.AppendText(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + " Unkown error."+ Environment.NewLine);
            }
            this.Devmes.ScrollToCaret();
        }

        private void SetStaticIP_Btn_Click(object sender, EventArgs e)
        {
            if (Device.SetStaticIP(StaticIP_Text.Text, SubnetMask_Text.Text, Gateway_Text.Text, Dns_Text.Text))
            {
                this.Devmes.AppendText(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + " Set static ip success" + Environment.NewLine);
            }
            else
            {
                this.Devmes.AppendText(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + "Set static ip error" + Environment.NewLine);
            }
        }

        private void gbRegion_Enter(object sender, EventArgs e)
        {

        }

        private void button3_Click(object sender, EventArgs e)
        {
        }

        private void bt_Getfim_Click(object sender, EventArgs e)
        {
            string firmwareVer = "";
            UInt32 error = 0;
            error = Device.GetFirmwareVersion(ref firmwareVer);
            if (error == 0)
            {
                txtFirm.Text = firmwareVer;
            }
            else
            {
                string msg = DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + " Get firm command sent failed.(" + error + ")";
                this.Devmes.AppendText(msg + Environment.NewLine);
                this.Devmes.ScrollToCaret();
            }
        }

        private void button1_Click_2(object sender, EventArgs e)
        {
            string sdkVersion = "";
            this.Devmes.AppendText(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + " Get SDK Version " + Environment.NewLine);
            Device.GetSdkVersion(ref sdkVersion);
            tx_sdkversion.Text = sdkVersion;
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            int duration = (System.Environment.TickCount - total_time);
            lblTotalDuration.Text = duration.ToString();
            lblSingulationRate.Text = (((float)singluationCount * 1000) / (float)duration).ToString("F01");
        }

        private void btnRetrieveallkeys_click(object sender, EventArgs e)
        {
            ArrayList list = new ArrayList();
            uint error = Device.GetAllKeys(ref list);
            if (error != 0)
            {
                string msg = DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + " Retrieve all keys command sent failed.(" + error + ")";
                this.Devmes.AppendText(msg + Environment.NewLine);
                this.Devmes.ScrollToCaret();
            }
            else {
                this.Devmes.AppendText(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + Environment.NewLine);
                foreach (var item in list)
                {
                    this.Devmes.AppendText(item + Environment.NewLine);
                }
            }
        }

        private void btnSetupCustomRegion_click(object sender, EventArgs e)
        {
            uint r1 = 0;
            uint r2 = 0;
            uint r3 = 0;
            uint r4 = 0;

            bool ret1 = uint.TryParse(txtCustomRegion1.Text, out r1);
            bool ret2 = uint.TryParse(txtCustomRegion2.Text, out r2);
            bool ret3 = uint.TryParse(txtCustomRegion3.Text, out r3);
            bool ret4 = uint.TryParse(txtCustomRegion4.Text, out r4);

            if (!ret1 || !ret2 || !ret3 || !ret4) {
                string msg = DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + " Set Antenna Sequence parameter is incorrect.(Sample:1,2,3,4)";
                this.Devmes.AppendText(msg + Environment.NewLine);
                this.Devmes.ScrollToCaret();
                return;
            }

            uint[] channelTable = { r1, r2, r3, r4 };
            ArrayList list = new ArrayList();

            for (int i = 0; i < channelTable.Length; i++)
            {
                if ((channelTable[i] > 4 || channelTable[i] < 1) || list.Contains(channelTable[i]))
                {
                    string msg = DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + " Set Antenna Sequence parameter is incorrect.(Sample:1,2,3,4)";
                    this.Devmes.AppendText(msg + Environment.NewLine);
                    this.Devmes.ScrollToCaret();
                    return;
                }
                else
                {
                    list.Add(channelTable[i]);
                }
            }

            uint error = Device.SetupCustomRegion(channelTable);
            if (error != 0)
            {
                string msg = DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + " Set antenna sequence command sent failed.(" + error + ")";
                this.Devmes.AppendText(msg + Environment.NewLine);
                this.Devmes.ScrollToCaret();
            }
            else {
                string msg = DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + " Set antenna sequence command sent successfully.";
                this.Devmes.AppendText(msg + Environment.NewLine);
                this.Devmes.ScrollToCaret();
            }
        }

        private void AsReaderP51N_Demo_Tool_FormClosing(object sender, FormClosingEventArgs e)
        {
            if (isConnected) {
                Device.Disconnect();
            }
        }

        private void btnCsvOut_Click(object sender, EventArgs e)
        {
            if (DatalistView.Items.Count == 0) return;
            string fileName = DateTime.Now.ToString("yyyyMMddHHmmssfff") + ".csv";
            System.Threading.Thread th = new System.Threading.Thread(ExportCSV);
            th.Start(fileName);
        }
        private void ExportCSV(object strFileName)
        {
            this.Invoke((EventHandler)delegate {
                try
                {
                    string savePath = ConfigurationManager.AppSettings["CsvDefaultPath"];
                    if (Directory.Exists(savePath) == false)
                    {
                        MessageBox.Show(savePath + "folder does not exists.");
                        return;
                    }
                    SaveFileDialog sfd = new SaveFileDialog();
                    sfd.RestoreDirectory = true;
                    sfd.Filter = "csv(*.csv)|*.csv|all(*.*)|*.*";
                    sfd.FileName = strFileName.ToString();
                    if (savePath != "") sfd.InitialDirectory = savePath;
                    //sfd.InitialDirectory = Application.StartupPath;
                    if (sfd.ShowDialog() == DialogResult.OK)
                    {
                        FileStream fs = new FileStream(sfd.FileName, FileMode.Create);
                        StreamWriter sw = new StreamWriter(fs, Encoding.Default);
                        //header
                        for (int i = 0; i < DatalistView.Columns.Count; i++)
                        {
                            sw.Write(DatalistView.Columns[i].Text);
                            if (DatalistView.Columns.Count - 1 > i) sw.Write(",");
                        }
                        sw.Write(Environment.NewLine);
                        for (int i = 0; i < DatalistView.Items.Count; i++)
                        {
                            for (int j = 0; j < DatalistView.Items[i].SubItems.Count; j++)
                            {
                                sw.Write(DatalistView.Items[i].SubItems[j].Text);
                                if (DatalistView.Items[i].SubItems.Count - 1 > j) sw.Write(",");
                            }
                            sw.Write(Environment.NewLine);
                        }
                        sw.Flush();
                        sw.Close();
                        this.Devmes.AppendText(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + " Export csv file successed." + Environment.NewLine);
                        this.Devmes.ScrollToCaret();
                    }
                }
                catch (Exception ex)
                {
                    this.Devmes.AppendText(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + " Export csv file failed." + ex.Message + Environment.NewLine);
                    this.Devmes.ScrollToCaret();
                }
            });
            
        }
    }
}
